﻿@backSync
Feature: Back Sync
Synchronizing changes from TFS/TMT to feature file.

@done @automated
Scenario: Steps are synchronized back to feature file
	Given there is a VSTS project
	And the synchronizer is configured to enable back syncing
	And there is a feature file in the local workspace that was not synchronized yet
		"""
		Feature: Sample feature

		Scenario Outline: Sample scenario outline
			When <something> happens with <someone>

		Examples:
			| something | someone |
			| foo       | Joe     |
			| bar       | Jill    |
			| boz       | Jack    | 
		"""
	And the feature file has been synchronized already
	When the test case steps are updated to 
		"""
		When @something really happens with @someone
		Then this is good for @someone
		"""
	And the SpecSync pull is executed
	Then the feature file in the local workspace should have been updated to contain
		"""
		Feature: Sample feature

		@tc:[id-of-test-case]
		Scenario Outline: Sample scenario outline
			When <something> really happens with <someone>
			Then this is good for <someone>

		Examples:
			| something | someone |
			| foo       | Joe     |
			| bar       | Jill    |
			| boz       | Jack    | 
		"""

@done @automated
Scenario: Parameter values are synchronized back to Scenario Outline
	Given there is a VSTS project
	And the synchronizer is configured to enable back syncing
	And there is a feature file in the local workspace that was not synchronized yet
		"""
		Feature: Sample feature

		Scenario Outline: Sample scenario outline
			When <something> happens with <someone>

		Examples:
			| something | someone |
			| foo       | Joe     |
			| bar       | Jill    |
			| boz       | Jack    | 
		"""
	And the feature file has been synchronized already
	When the test case parameter data is updated to
		| something | someone |
		| one       | Tarzan  |
		| two       | Thomas  |
	And the SpecSync pull is executed
	Then the feature file in the local workspace should have been updated to contain
		"""
		Feature: Sample feature

		@tc:[id-of-test-case]
		Scenario Outline: Sample scenario outline
			When <something> happens with <someone>

		Examples:
			| something | someone |
			| one       | Tarzan  |
			| two       | Thomas  |
		"""

@done @automated
Scenario: Title is synchronized back to feature file
	Given there is a VSTS project
	And the synchronizer is configured to enable back syncing
	And there is a feature file in the local workspace that was not synchronized yet
		"""
		Feature: Sample feature

		Scenario Outline: Sample scenario outline
			When <something> happens with <someone>

		Examples:
			| something | someone |
			| foo       | Joe     |
			| bar       | Jill    |
			| boz       | Jack    | 
		"""
	And the feature file has been synchronized already
	When the test case title is updated to 'Scenario Outline: Updated scenario outline'
	And the SpecSync pull is executed
	Then the feature file in the local workspace should have been updated to contain
		"""
		Feature: Sample feature

		@tc:[id-of-test-case]
		Scenario Outline: Updated scenario outline
			When <something> happens with <someone>

		Examples:
			| something | someone |
			| foo       | Joe     |
			| bar       | Jill    |
			| boz       | Jack    | 
		"""

@done @automated
Scenario: Pull a normal test case to a scenario
	Given there is a VSTS project
	And the synchronizer is configured to enable back syncing
	And there is a feature file in the local workspace that was not synchronized yet
		"""
		Feature: Sample feature

		Scenario: Sample scenario
			When something happens with someone
		"""
	And the feature file has been synchronized already
	When the test case title is updated to 'Scenario: Updated scenario'
	And the SpecSync pull is executed
	Then the feature file in the local workspace should have been updated to contain
		"""
		Feature: Sample feature

		@tc:[id-of-test-case]
		Scenario: Updated scenario
			When something happens with someone
		"""

@done @automated
Scenario: Both the test case and the scenario were changed (conflict)
	Given there is a VSTS project
	And the synchronizer is configured to enable back syncing
	And there is a scenario that was already synchronized before
		"""
		@tc:[id-of-test-case]
		Scenario: Sample scenario
			When I do something
		"""
	When the test case title is updated to 'Scenario: Updated scenario on remote'
	When the scenario is updated to
		"""
		@tc:[id-of-test-case]
		Scenario: Updated scenario on local
			When I do something new
		"""
	And the SpecSync pull is executed with chosing "Remote" for conflict
	Then the feature file in the local workspace should have been updated to contain
		"""
		Feature: Sample feature
		@tc:[id-of-test-case]
		Scenario: Updated scenario on remote
			When I do something
		"""

@done @automated
Scenario: Quit from conflict
	Given there is a VSTS project
	And the synchronizer is configured to enable back syncing
	And there is a scenario that was already synchronized before
		"""
		@tc:[id-of-test-case]
		Scenario: Sample scenario
			When I do something
		"""
	When the test case title is updated to 'Scenario: Updated scenario on remote'
	When the scenario is updated to
		"""
		@tc:[id-of-test-case]
		Scenario: Updated scenario on local
			When I do something new
		"""
	And the SpecSync pull is executed with chosing "Quit" for conflict
	Then the synchronization should finish with errors

@done @automated
Scenario: Skip from conflict
	Given there is a VSTS project
	And the synchronizer is configured to enable back syncing
	And there is a scenario that was already synchronized before
		"""
		@tc:[id-of-test-case]
		Scenario: Sample scenario
			When I do something
		"""
	When the test case title is updated to 'Scenario: Updated scenario on remote'
	When the scenario is updated to
		"""
		@tc:[id-of-test-case]
		Scenario: Updated scenario on local
			When I do something new
		"""
	And the SpecSync pull is executed with chosing "Skip" for conflict
	Then the synchronization should not fail
