﻿Feature: Sync Scope and Filtering

@configuration @done @automated
Scenario: Only selected scenarios are in scope (by tag expression)
	Out of scope scenarios are not added (removed) from test suite. See feature "Test Suite Synchronization"
	Given there is a VSTS project
	And there is a feature file in the local workspace that was not synchronized yet
		"""
		Feature: Sample feature

		@finished
		Scenario: Finished scenario
			When I do something
		@manual @finished
		Scenario: Manual scenario
			When I do something
		@ignore
		Scenario: Ignored scenario
			When I do something

		Scenario: Unfinished scenario
			When I do something
		"""
	And the synchronizer is configured to scope scenarios tagged with "@finished and not (@manual or @ignored)"
	When the SpecFlow2TFS synchronization is executed for the project and the local workspace
	Then the scenario "Scenario: Finished scenario" was synchronized
	But the scenario "Scenario: Manual scenario" was not synchronized
	And the scenario "Scenario: Ignored scenario" was not synchronized
	And the scenario "Scenario: Unfinished scenario" was not synchronized

@configuration @done @automated
Scenario: Only selected scenarios are filtered (by tag expression)
	Filtered out scenarios are added (kept) in test suite. See feature "Test Suite Synchronization"
	Given there is a VSTS project
	And there is a feature file in the local workspace that was not synchronized yet
		"""
		Feature: Sample feature

		@done @current_sprint
		Scenario: Scenario in focus now
			When I do something

		@done
		Scenario: Other scenario
			When I do something
		"""
	And the synchronizer is configured to filter senario tags with "@current_sprint and @done"
	When the SpecFlow2TFS synchronization is executed for the project and the local workspace
	Then the scenario "Scenario: Scenario in focus now" was synchronized
	But the scenario "Scenario: Other scenario" was not synchronized

